//+------------------------------------------------------------------+
//|                                                              rsx |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    6
#property indicator_color1     LimeGreen
#property indicator_color2     Orange
#property indicator_color3     Orange
#property indicator_color4     Gold
#property indicator_color5     LimeGreen
#property indicator_color6     Red
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_style5     STYLE_DOT
#property indicator_style6     STYLE_DOT
#property indicator_minimum    0
#property indicator_maximum    100

//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuy(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i );
   double dzSell(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i );
#import

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame           = PERIOD_CURRENT;
extern int                Length              = 14;
extern ENUM_APPLIED_PRICE Price               = PRICE_TYPICAL;
extern double             Filter              = 10;
extern double             FilterSpeed         = 3;
extern bool               FilterAdaptive      = true;
extern int                SignalPeriod        = 10;
extern ENUM_MA_METHOD     SignalType          = MODE_LWMA;
extern int                Depth               = 3;
extern double             Speed               = 0.25;
extern int                DzLookBackBars      = 35;
extern double             DzBuyProbability    = 0.20;
extern double             DzSellProbability   = 0.20;
extern bool               alertsOn            = false;
extern bool               alertsOnMaCross     = true;
extern bool               alertsOnSlopeChange = true;
extern bool               alertsOnCurrent     = true;
extern bool               alertsMessage       = true;
extern bool               alertsSound         = false;
extern bool               alertsEmail         = false;
extern string             soundfile           = "alert2.wav";
extern bool               Interpolate         = true;


//
//
//
//
//

double rsx[];
double rsxda[];
double rsxdb[];
double signal[];
double dzu[];
double dzd[];
double slope[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,rsx);
      SetIndexBuffer(1,rsxda);
      SetIndexBuffer(2,rsxdb);
      SetIndexBuffer(3,signal);
      SetIndexBuffer(4,dzu);
      SetIndexBuffer(5,dzd);
      SetIndexBuffer(6,slope);
      SetIndexBuffer(7,trend);
        
        //
        //
        //
        //
        //
        
        Speed             = MathMax(MathMin(1.5,Speed),0.1);
        Depth             = MathMax(MathMin(10 ,Depth),1);
        indicatorFileName = WindowExpertName();
        returnBars        = (TimeFrame==-99);
        TimeFrame         = MathMax(TimeFrame,_Period);
        
        //
        //
        //
        //
        //
         
        IndicatorShortName(timeFrameToString(TimeFrame)+" Dz Rsx ("+Length+","+Depth+","+DoubleToStr(Speed,2)+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrkBuffer[][41];

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { rsx[0] = limit+1; return(0); }
         
   //
   //
   //
   //
   //
   
   if (TimeFrame==_Period)
   {
     double Kg = (3.0)/(2.0+Length); 
     double Hg = 1.0-Kg;
     if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars);
     if  (slope[limit] == -1) ClearPoint(limit,rsxda,rsxdb);
     for(i=limit, r=Bars-i-1; i>=0; i--, r++)
     {
        wrkBuffer[r][0] = iOma(iMA(NULL,0,1,0,MODE_SMA,Price,i),Filter,FilterSpeed,FilterAdaptive,i);
        if (i==(Bars-1)) { for (int c=1; c<13; c++) wrkBuffer[r][c] = 0; continue; }  

        //
        //
        //
        //
        //
      
        double mom = wrkBuffer[r][0]-wrkBuffer[r-1][0];
        double moa = MathAbs(mom);
        for (int k=0; k<Depth; k++)
        {
           int kk = k*4;
              wrkBuffer[r][kk+1] = Kg*mom                + Hg*wrkBuffer[r-1][kk+1];
              wrkBuffer[r][kk+2] = Kg*wrkBuffer[r][kk+1] + Hg*wrkBuffer[r-1][kk+2]; mom =         1.5*wrkBuffer[r][kk+1] - Speed * wrkBuffer[r][kk+2];
              wrkBuffer[r][kk+3] = Kg*moa                + Hg*wrkBuffer[r-1][kk+3];
              wrkBuffer[r][kk+4] = Kg*wrkBuffer[r][kk+3] + Hg*wrkBuffer[r-1][kk+4]; moa = MathAbs(1.5*wrkBuffer[r][kk+3] - Speed * wrkBuffer[r][kk+4]);
        }
        if (moa != 0)
             rsx[i] = MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00); 
        else rsx[i] = 0;
      
        //
        //
        //
        //
        //
        
        dzu[i] = dzBuy (rsx, DzBuyProbability,  DzLookBackBars, Bars, i);
        dzd[i] = dzSell(rsx, DzSellProbability, DzLookBackBars, Bars, i);
        rsxda[i] = EMPTY_VALUE;
        rsxdb[i] = EMPTY_VALUE;
        slope[i] = slope[i+1];
           if (rsx[i]>rsx[i+1]) slope[i] =  1;
           if (rsx[i]<rsx[i+1]) slope[i] = -1;
           if (slope[i] == -1) PlotPoint(i,rsxda,rsxdb,rsx);
   }
   for (i=limit; i >= 0; i--)
   {
        trend[i]  = trend[i+1];
        signal[i] = iMAOnArray(rsx,0,SignalPeriod,0,SignalType,i);
         if (rsx[i]>signal[i]) trend[i] =  1;
         if (rsx[i]<signal[i]) trend[i] = -1;
   }         
   manageAlerts();        
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   if  (slope[limit] == -1) ClearPoint(limit,rsxda,rsxdb);
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         rsx[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,Filter,FilterSpeed,FilterAdaptive,SignalPeriod,SignalType,Depth,Speed,DzLookBackBars,DzBuyProbability,DzSellProbability,alertsOn,alertsOnMaCross,alertsOnSlopeChange,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,0,y);
         
         rsxda[i]  = EMPTY_VALUE;
         rsxdb[i]  = EMPTY_VALUE;
         signal[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,Filter,FilterSpeed,FilterAdaptive,SignalPeriod,SignalType,Depth,Speed,DzLookBackBars,DzBuyProbability,DzSellProbability,alertsOn,alertsOnMaCross,alertsOnSlopeChange,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,3,y);
         dzu[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,Filter,FilterSpeed,FilterAdaptive,SignalPeriod,SignalType,Depth,Speed,DzLookBackBars,DzBuyProbability,DzSellProbability,alertsOn,alertsOnMaCross,alertsOnSlopeChange,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,4,y);
         dzd[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,Filter,FilterSpeed,FilterAdaptive,SignalPeriod,SignalType,Depth,Speed,DzLookBackBars,DzBuyProbability,DzSellProbability,alertsOn,alertsOnMaCross,alertsOnSlopeChange,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,5,y);
         slope[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,Filter,FilterSpeed,FilterAdaptive,SignalPeriod,SignalType,Depth,Speed,DzLookBackBars,DzBuyProbability,DzSellProbability,alertsOn,alertsOnMaCross,alertsOnSlopeChange,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,6,y);
         trend[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,Filter,FilterSpeed,FilterAdaptive,SignalPeriod,SignalType,Depth,Speed,DzLookBackBars,DzBuyProbability,DzSellProbability,alertsOn,alertsOnMaCross,alertsOnSlopeChange,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,7,y);
           
         //
         //
         //
         //
         //
            
         if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame,y);
           for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
           for(int s = 1; s < n; s++)
           {
  	           rsx[i+s]    = rsx[i]    + (rsx[i+n]    - rsx[i])    * s/n;
  	           signal[i+s] = signal[i] + (signal[i+n] - signal[i]) * s/n;
  	           dzu[i+s]    = dzu[i]    + (dzu[i+n]    - dzu[i])    * s/n;
  	           dzd[i+s]    = dzd[i]    + (dzd[i+n]    - dzd[i])    * s/n;
  	        }
    }
    for (i=limit;i>=0;i--) if (slope[i] == -1) PlotPoint(i,rsxda,rsxdb,rsx);
return(0);
}


//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workOma[][7];
#define F01 0
#define F02 1
#define F03 2
#define F04 3
#define F05 4
#define F06 5
#define prc 6

//
//
//
//
//

double iOma(double price, double averagePeriod, double constant, bool adaptive, int r, int s=0)
{
   if (averagePeriod <=1) return(price);
   if (ArrayRange(workOma,0) != Bars) ArrayResize(workOma,Bars); r=Bars-r-1; s *=7;
   if (r<=1) 
   {
      for (int i=0; i<6; i++) workOma[r][i  +s] = 0;
                              workOma[r][prc+s] = price;
                              return(price);
   }      
   double f01=workOma[r-1][F01+s];  double f02=workOma[r-1][F02+s];
   double f03=workOma[r-1][F03+s];  double f04=workOma[r-1][F04+s];
   double f05=workOma[r-1][F05+s];  double f06=workOma[r-1][F06+s];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = MathMin(averagePeriod,r)/2.0;
         double maxPeriod = MathMin(minPeriod*5.0,r);
         int    endPeriod = (int)MathCeil(maxPeriod);
         double tsignal   = MathAbs((price-workOma[r-endPeriod][prc+s]));
         double noise     = 0.00000000001;

            for(i=1; i<endPeriod; i++) noise=noise+MathAbs(price-workOma[r-i][prc+s]);

         averagePeriod = ((tsignal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double Kg = (2.0+constant)/(1.0+constant+averagePeriod);
      double Hg = 1.0-Kg;

      f01 = Kg * price + Hg * f01; f02 = Kg * f01 + Hg * f02; double v01 = 1.5 * f01 - 0.5 * f02;
      f03 = Kg * v01   + Hg * f03; f04 = Kg * f03 + Hg * f04; double v02 = 1.5 * f03 - 0.5 * f04;
      f05 = Kg * v02   + Hg * f05; f06 = Kg * f05 + Hg * f06; double v03 = 1.5 * f05 - 0.5 * f06;

   //
   //
   //
   //
   //

   workOma[r][F01+s] = f01;  workOma[r][F02+s] = f02;
   workOma[r][F03+s] = f03;  workOma[r][F04+s] = f04;
   workOma[r][F05+s] = f05;  workOma[r][F06+s] = f06;
   workOma[r][prc+s] = price;
   return(v03);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      static string   type1 = "";
      static datetime time1 = 0;
      if (alertsOnMaCross && trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(type1,time1,"crossed signal line up");
         if (trend[whichBar] ==-1) doAlert(type1,time1,"crossed signal line down");
      }         
      static string   type2 = "";
      static datetime time2 = 0;
      if (alertsOnSlopeChange && slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar] == 1) doAlert(type2,time2,"changed slope to up");
         if (slope[whichBar] ==-1) doAlert(type2,time2,"changed slope to down");
      }         
   }
}   

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(_Period)+" dz rsx 3 oma ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," dz rsx 3 oma "),message);
          if (alertsSound)   PlaySound(soundfile);
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void ClearPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
   {
      if (first[i+2] == EMPTY_VALUE) 
      {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
      }
      else
      {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
      }
   }
   else
   {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}